#!/usr/local/bin/perl
#################################################
# epassreg.cgi - Returns form requesting user's
# Username and E-mail address.  Generates password,
# e-mails it to user, and stores user data in log for
# retrieval via epasschk.cgi.
#################################################
# CONFIGURATION SECTION

# The path to sendmail.  The default usually works.

	$sendmail = '/usr/lib/sendmail';

# The return address for the generated e-mail.  Your
# e-mail address is fine.

	$admin = '';

# The path to the log file.  If your storing the log
# with your scripts, you don't need to change this.

	$logpath = '.';

# The name of your log file.  To enhance security,
# change this to something hard to guess.

	$log = 'users.log';

# Set to 'yes' to force user to provide their POP3 e-mail address.
# If set to 'no', any address can be used.

	$force_domain = 'yes';

# URL of the resource you're adding password access to.

	$url = 'http://www.domain.com/~user/';

# END OF CONFIGURATION
#################################################

&get_form_data;
&get_domain;
$FORM{'email'} .=$domain if exists($FORM{'email'}) and $force_domain eq 'yes';
&register($FORM{'name'},$FORM{'email'});


sub get_form_data {
	read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
	if ($ENV{'QUERY_STRING'}) {
		$buffer = "$buffer\&$ENV{'QUERY_STRING'}"
	}
	@pairs = split(/&/,$buffer);
	foreach $pair (@pairs) {
		($name,$value) = split(/=/,$pair);
		$value =~ tr/+/ /;
		$value =~ s/\t//g;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$FORM{$name} = $value
	}
}

sub register {
	my ($name) = shift(@_);
	my ($email) = shift(@_);

	unless($name and $email) {
		print "Content-type: text/html\n\n";
		print "<html><head></head><body>\n";
		print "To register, enter your desired username and complete your valid email address below.\n";
		print "<form action=$ENV{'SCRIPT_NAME'} METHOD=POST>\n";
		print "<table><tr><td>Username:</td><td><input type=text name=name value=\"\"><br></td></tr>\n";
		print "<tr><td>E-mail:</td><td><input type=text name=email value=\"\">\n";
		print "<B>$domain</B>\n" if $force_domain eq 'yes';
		print "<br></td></tr></table>\n";
		print "<input type=submit value=\"Register\"></form><p><hr>\n";
		print "If you are unable to enter a valid email address above, you can request one via <A HREF=\"mailto:$admin\">E-mail</A>.\n";
		print "</body></html>";
		exit;
	}

	# check userpass file

	if (($email =~ /.+?\@.+?\..+?/) and ($name)) {
		unless(open(USERFILE,"$logpath/$log")) {
		        &system_error("Couldn't open your user info file.  Check your paths and permissions.\n");
		        exit;
		}
		@user_info = <USERFILE>;
		close(USERFILE);
		chomp(@user_info);

		for $info (@user_info) {
			@info = split (/\t/, $info);
			if($info[2] eq $email) {
				print "Content-type: text/html\n\n";
				print "<html><head></head><body>\n";
				print "<b>Our records show that someone is already registered using that e-mail address.</b><br>\n";
				print " If you entered incorrect information, use your browser's [Back] button to return to the registration form.\n";
				print "</body></html>";
				exit;
			}
			if($info[0] eq $name) {
				print "Content-type: text/html\n\n";
				print "<html><head></head><body>\n";
				print "<h1>Access denied</h1>\n";
				print "That name has already been taken.  Use your browser's [Back] button to return to the form, and chosse another.\n";
				print "</body></html>";
				exit;
			}
		}

		# generate password,

	    srand;
		$random = "abcdefghijklmnopqrstuvwxyz1234567890";
		$password = "";
		for (1..6) {
	        $password .= substr($random,int(rand(36)),1);
		}

		unless(open(USERFILE,">>$logpath/$log")) {
		        &system_error("Couldn't open user file.\n");
		        exit;
		}
		
		print USERFILE "$name\t$password\t$email\n";
		close(USERFILE);

		open(EMAIL, "|$sendmail -t -oi");
		print EMAIL "From: $name\n";
		print EMAIL "To: $email\n";
		print EMAIL "Subject: Password for Chatroom\n\n";
		print EMAIL "Your Chatroom Password is: $password\n";
		close(EMAIL);

		print "Content-type: text/html\n\n";
		print "<html><head></head><body>\n";
		print "<h1>Thanks for registering.</h1>\n";
		print "Your password will be arriving via e-mail shortly.  When it does, you can return <A HREF=\"$url\">HERE</A> and log on.\n";
		print "</body></html>";
		exit;
		

	}

print "Content-type: text/html\n\n";
print "<html><head></head><body>\n";
print "<h1>The information you provided was incomplete.</h1>  Please use your browser's [Back] button to return to the form.\n";
print "</body></html>";
exit;

}

################################
# Error Subs
sub system_error {
    local($errmsg) = @_;
    &print_header("System Error");
    print $errmsg;
    &print_footer;
}

sub print_header {
    local($title) = @_;
    print "Content-type: text/html\n\n";
    print "<HTML>\n";
    print "<HEAD>\n";
    print "<TITLE>$title</TITLE>\n";
    print "</HEAD>\n";
    print "<BODY>\n";
    print "<H1>$title</H1>\n";
}

sub print_footer {
    print "</BODY>\n";
    print "</HTML>\n";
}
sub get_domain {
	$remote_host = $ENV{'REMOTE_HOST'};
	@rhlist = split (/\./,$remote_host);
	$domain = "$rhlist[$#rhlist-1].$rhlist[$#rhlist]";
}
